package tictactoe.bThreads;

import static bp.eventSets.EventSetConstants.none;
import static bp.BProgram.*; 

import static tictactoe.events.StaticEvents.gameOver;

import java.util.HashSet;
import java.util.Set;

import tictactoe.events.Move;
import tictactoe.events.X;
import bp.BProgram;
import bp.BThread;
import bp.eventSets.EventSet;
import bp.exceptions.BPJException;

/**
 * BThread for not allowing two symbols in the same square.
 */
@SuppressWarnings("serial")
public class SquareTaken extends BThread {
	private int row;
	private int col;

	public void runBThread() throws BPJException {

//		interruptingEvents = new EventSet(gameOver);

		labelNextVerificationState("?(" + row + "," + col + ")");
		Move move = new Move(row, col);
		move.setName("(" + row + "," + col + ")");
		// Wait for any move for a given square
		bp.bSync(none, move, none);
		Move lastMove = (Move) bp.lastEvent;
		if (lastMove instanceof X)
			labelNextVerificationState("X(" + row + "," + col + ")");
		else
			labelNextVerificationState("O(" + row + "," + col + ")");
		bp.bSync(none, none, move);

	}

	public SquareTaken(int row, int col) {
		super("SquareTaken(" + row + "," + col + ")");
		this.row = row;
		this.col = col;

	}

	static public Set<BThread> constructInstances() {

		Set<BThread> set = new HashSet<BThread>();

		for (int row = 0; row < 3; row++) {
			for (int col = 0; col < 3; col++) {
				set.add(new SquareTaken(row, col));
			}
		}
		return set;
	}
}
