package tictactoe.externalApp;

import tictactoe.bThreads.*;
import tictactoe.environment.XAllMoves;
import bApplication.BApplication;
import bp.BProgram;
import bp.BThread;
import static bp.BProgram.*;

/**
 * The main entry point to the TicTacToe program.
 */
public class TicTacToe implements BApplication {
	public static TTTDisplay disp;

	/**
	 * Main program entry point
	 * 
	 * @param args
	 *            Command line parameters (ignored)
	 */

	static public void main(String arg[]) {
		try {

			BProgram.startBApplication(TicTacToe.class, "tictactoe");

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void runBApplication() {

		// Register scenarios

//		// Start the graphical user interface
		disp = new TTTDisplay(bp);
//		bp.add(new UserMove(), 0.5);
		bp.add(new UpdateTTTDisplay(), 0.6);
//		bp.add(new TrackBoard(), 0.65);

		bp.add(new DetectDraw(), 1.0);

// 		bp.add(new DeclareWinner(), 2.5);
		bp.add(new EnforceTurns(), 2.0);

		double pr = 3.0;
		for (BThread sc : SquareTaken.constructInstances())
			bp.add(sc, pr += 0.001);

		pr = 4.0;
		for (BThread sc : DetectXWin.constructInstances())
			bp.add(sc, pr += 0.001);
		
		pr = 5.0;
		for (BThread sc : DetectOWin.constructInstances())
			bp.add(sc, pr += 0.001);
		
		pr = 6.0;
		for (BThread sc : AddThirdO.constructInstances())
			bp.add(sc, pr += 0.001);

		pr = 7.0;
		for (BThread sc : PreventThirdX.constructInstances())
			bp.add(sc, pr += 0.001);

		pr = 8.0;
		for (BThread sc : PreventXFork.constructInstances()){ // corner-edge
			bp.add(sc, pr += 0.001);
		}

		bp.add(new PreventAnotherXFork(), 9.0); // corner-corner

		pr = 10.0;
		for (BThread sc : PreventYetAnotherXFork.constructInstances()){ // edge-edge
			bp.add(sc, pr += 0.001);
		}
		
		bp.add(new DefaultMoves(), 11.0);

		bp.add(new XAllMoves(), 15.0);
		 
		// Start the scenarios

		bp.startAll();
	}

}
